#
# Local macros/define
#
%if %{undefined package_revision}
%global package_revision 1
%endif

%if %{undefined make_build}
%global make_build %{__make} %{?_smp_mflags}
%endif

%if %{undefined autosetup}
%global autosetup %setup -q
%endif

%global gittag v1.0.71

%if %{undefined make_check}
%global make_check 1
%endif

#
# main package
#
Summary: NoSQL Key Value Store(KVS) tool and library
Name: k2hash
Version: 1.0.71
Release: %{package_revision}%{?dist}
License: MIT

URL: https://github.com/yahoojapan/k2hash
Source0: https://github.com/yahoojapan/k2hash/archive/%{gittag}/%{name}-%{version}.tar.gz
Requires: libfullock%{?_isa} >= 1.0.36
BuildRequires: git-core gcc-c++ make libtool libfullock-devel >= 1.0.36 nss-devel

%description
K2HASH is a NoSQL(key value store) tool and a library supported by Yahoo!
JAPAN.  K2HASH creates/writes/reads a file by using its library. The K2HASH
library has the following features:
- Supports multi-threading and multi-processing program.
- Expands data area.
- Switches accessing only memory and data file directly.
- Puts transaction.
- Archiving.
- Replaces hash function like plugin.
- Replaces transaction.

Please visit the following website and get more details at:
https://github.com/yahoojapan/k2hash

%prep
%autosetup -n %{name}-%{version}

%build
./autogen.sh
%configure --disable-static --with-nss
%make_build

%install
%make_install
find %{buildroot} -name '*.la' -exec rm -f {} ';'

%if %{make_check}
%check
%{__make} check
%endif

%if %{defined ldconfig_scriptlets}
%ldconfig_scriptlets
%else
%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig
%endif

%if 0%{?rhel} == 6
%clean
rm -rf %{buildroot}
%endif

%files
%if 0%{?rhel} == 6
%doc COPYING
%defattr(-,root,root)
%else
%license COPYING
%endif
%doc README AUTHORS ChangeLog
%{_libdir}/*.so.1*
%{_mandir}/man1/*
%{_bindir}/*

#
# devel package
#
%package devel
Summary: NoSQL Key Value Store(KVS) library (development)
Requires: %{name}%{?_isa} = %{version}-%{release}, libfullock-devel%{?_isa} >= 1.0.36

%description devel
Development package for building with k2hash shared library.
This package has header files and symbols for it.

%files devel
%if 0%{?rhel} == 6
%defattr(-,root,root)
%endif
%doc README AUTHORS ChangeLog
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc

%changelog
* Sun Aug 18 2019 Hirotaka Wakabayashi <hiwkby@yahoo.com>   1.0.71-1
- Packaging for Fedora

* Fri May 17 2019 Takeshi Nakatani <ggtakec@gmail.com>   1.0.71
- Fixed a bug that leaked file descriptor - #31

* Tue Mar 12 2019 Takeshi Nakatani <ggtakec@gmail.com>   1.0.70
- Fixed codes for cppcheck 1.87 - #28

* Thu Jan 17 2019 Takeshi Nakatani <ggtakec@gmail.com>   1.0.69
- Fixed incorporation of multibyte characters - #25
- Added check using cppcheck - #24
- Reflected the spelling check result for all sources - #23
- Remove dead code - #21

* Tue Dec 11 2018 Takeshi Nakatani <ggtakec@gmail.com>   1.0.68
- Updated common build tool files

* Wed Dec 05 2018 Takeshi Nakatani <ggtakec@gmail.com>   1.0.67
- Updated configure.ac and packaging scripts/files

* Fri Nov 30 2018 Takeshi Nakatani <ggtakec@gmail.com>   1.0.66
- Fixed bug in debian package creation

* Thu Nov 29 2018 Takeshi Nakatani <ggtakec@gmail.com>   1.0.65
- Changed to strict packaging and changed documents

* Wed Nov 07 2018 Takeshi Nakatani <ggtakec@gmail.com>   1.0.64
- Fixed a bug segmentation fault exiting tr thread

* Thu Oct 04 2018 Takeshi Nakatani <ggtakec@gmail.com>   1.0.63
- Fixed requires in specfile
- Fixed fatal error in destructor code corresponding to SIOF etc
- Fixed fatal error in destructing mmap info and etc

* Fri Jun 29 2018 Takeshi Nakatani <ggtakec@gmail.com>   1.0.61
- avoid static object initialization order problem(SIOF)

* Tue Jun 26 2018 Takeshi Nakatani <ggtakec@gmail.com>   1.0.60
- Fixed build options for pthread

* Thu Jun 21 2018 Takeshi Nakatani <ggtakec@gmail.com>   1.0.59
- Fixed a bug about lead loop

* Wed May 16 2018 Takeshi Nakatani <ggtakec@gmail.com>   1.0.58
- Cleanup credit comments in sources
- Supported multi crypt libraries(NSS/gcrypt/nettle)
- Changed build logic to new for rpm/debian packaging
- Fixed build error with openssl 1.1.0

* Tue Mar 28 2017 Takeshi Nakatani <ggtakec@gmail.com>   1.0.57
- Fixed type qualifiers ignored on function return type
- Strict/Robust queue processing for conflicting
- Fixed deadlock at updating key with subkeys

* Tue Mar 21 2017 Takeshi Nakatani <ggtakec@gmail.com>   1.0.55
- Updated fullock submodule v1.0.24
- Added lib_version_for_link option to make_valiables.sh
- Fixed failed adding subkeys to encrypted key with no value

* Tue Feb 14 2017 Takeshi Nakatani <ggtakec@gmail.com>   1.0.54
- Updated dependency for fixing bugs in libfullock

* Mon Feb 06 2017 Takeshi Nakatani <ggtakec@gmail.com>   1.0.53
- Fixed mistaking codes - #3
- Fixed error/warning for compiling and changed travis.yaml - #2

* Wed Dec 07 2016 Takeshi Nakatani <ggtakec@gmail.com>   1.0.52
- First version of open sorce on Github
